import javax.swing.*;
import java.awt.*;

class OrbitPanel extends JPanel {

	private double a, b;

    final static int NX = 200,
                     NY = 200;

    final static double
        xmin = -2,
        xmax = 2,
        ymin = -2,
        ymax = 2;

    public OrbitPanel(double aa, double bb) {
        super();
        a = aa; b = bb;
    }

    public void setCoords(double x, double y) {
        a = x; b = y;
        repaint();
    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        double x = a, y = b;
        g.setColor(Color.white);
        g.fillRect(0,0,NX,NY);
        g.setColor(Color.black);
        for (int k = 1; k <= 100; k++) {
            double z = x * x - y * y + a;
            y = 2 * x * y + b;
            x = z;
            int i = (int) (NX * (x - xmin) / (xmax - xmin));
            int j = (int) (NY * (y - ymax) / (ymin - ymax));
            if (i >= 2 && j>=2 && i < NX-2 && j < NX-2)
                g.fillRect(i - 2, j - 2, 4, 4);
        }
    }
    
    public Dimension getPreferredSize() {
        return new Dimension(NX, NY);
    }
}